open GtkWindow
open GtkMisc
open GtkBase

let string_of_flag = function
  | `START -> "START"
  | `REDIRECTING -> "REDIRECTING"
  | `TRANSFERRING -> "TRANSFERRING"
  | `NEGOTIATING -> "NEGOTIATING"
  | `STOP -> "STOP"
  | `IS_REQUEST -> "IS_REQUEST"
  | `IS_DOCUMENT -> "IS_DOCUMENT"
  | `IS_NETWORK -> "IS_NETWORK"
  | `IS_WINDOW -> "IS_WINDOW"

  | `FAILED_DNS -> "FAILED_DNS"
  | `FAILED_CONNECT -> "FAILED_CONNECT"
  | `FAILED_TIMEOUT -> "FAILED_TIMEOUT"
  | `FAILED_USERCANCELED -> "FAILED_USERCANCELED"

  | `DEFAULTCHROME -> "DEFAULTCHROME"
  | `WINDOWBORDERSON -> "WINDOWBORDERSON"
  | `WINDOWCLOSEON -> "WINDOWCLOSEON"
  | `WINDOWRESIZEON -> "WINDOWRESIZEON"
  | `MENUBARON -> "MENUBARON"
  | `TOOLBARON -> "TOOLBARON"
  | `LOCATIONBARON -> "LOCATIONBARON"
  | `STATUSBARON -> "STATUSBARON"
  | `PERSONALTOOLBARON -> "PERSONALTOOLBARON"
  | `SCROLLBARSON -> "SCROLLBARSON"
  | `TITLEBARON -> "TITLEBARON"
  | `EXTRACHROMEON -> "EXTRACHROMEON"
  | `ALLCHROME -> "ALLCHROME"
  | `WINDOWRAISED -> "WINDOWRAISED"
  | `WINDOWLOWERED -> "WINDOWLOWERED"
  | `CENTERSCREEN -> "CENTERSCREEN"
  | `DEPENDENT -> "DEPENDENT"
  | `MODAL -> "MODAL"
  | `OPENASDIALOG -> "OPENASDIALOG"
  | `OPENASCHROME -> "OPENASCHROME"
;;

let string_of_flags flags = 
  String.concat " | " (List.map string_of_flag flags)
;;

let main () =
  let _ = GMain.Main.init ~setlocale: true () in
  let w = GWindow.window ~title: "gmmm" 
                         ~width: 600 ~height: 480 
                         ~allow_shrink: true () in
  w#connect#destroy ~callback:GMain.Main.quit;

(*  GtkMozembed.set_comp_path "/usr/lib/mozilla"; *)
  let moz = GMozembed.mozembed ~packing: w#add () in
  moz#connect#link_message (fun () ->
    prerr_endline (Printf.sprintf "link_message -> %s" moz#get_link_message));
  moz#connect#js_status (fun () ->
    prerr_endline (Printf.sprintf "js_status -> %s" moz#get_js_status));
  moz#connect#location (fun () ->
    prerr_endline (Printf.sprintf "location -> %s" moz#get_location));
  moz#connect#title (fun () ->
    prerr_endline (Printf.sprintf "title -> %s" moz#get_title));
  moz#connect#progress_all (fun uri ~current ~max ->
    prerr_endline (Printf.sprintf "P %s [%d/%d]" 
		     (match uri with Some s -> s | None -> "???")
		     current max));
  moz#connect#net_start (fun () ->
    prerr_endline (Printf.sprintf "net_start"));
  moz#connect#net_stop (fun () ->
    prerr_endline (Printf.sprintf "net_stop"));
  moz#connect#new_window (fun chromes -> 
    prerr_endline (Printf.sprintf "new_window: %s"
		     (string_of_flags chromes)); 
    let w = GWindow.window ~title: "gmmm" ~width: 600 ~height: 480
	~allow_shrink: true () in 
    let moz = GMozembed.mozembed ~packing: w#add () in
    w#misc#show ();
    moz);

  moz#connect#open_uri (fun uri ->
    prerr_endline (Printf.sprintf "open_uri %s"
		       (match uri with Some s -> s | None -> "???"));
    false);
  moz#connect#net_state (fun progress_flags status_flags ->
    prerr_endline (Printf.sprintf "P %s\nS %s"
		     (string_of_flags progress_flags)
		     (string_of_flags status_flags)));
  (* not destroy_brsr but destroy_browser ? *)
  moz#connect#destroy_browser (fun () ->
    prerr_endline (Printf.sprintf "close")); 
  moz#connect#size_to (fun ~width ~height ->
    prerr_endline (Printf.sprintf "size_to %dx%d" width height));
  moz#connect#visibility (fun vis ->
    prerr_endline (Printf.sprintf "visibility %s" 
		     (if vis then "true" else "false")));
(*
  moz#connect#net_state_all (fun uri progress_flags status_flags ->
    prerr_endline (Printf.sprintf "N %s\n  P %s\n  S %s"
		     (match uri with Some s -> s | None -> "???")
		     (string_of_flags progress_flags)
		     (string_of_flags status_flags)));
*)

  moz#load_url "file:///home/furuse/public_html/index.html";

  w#misc#show ();
  GMain.Main.main ()

let () = main ()
