/* $Id: ml_gtkmozembed.c,v 1.1.1.1 2002/03/18 13:50:35 furuse Exp $ */

#include <stdio.h>

#include <string.h>
#include <gtk/gtk.h>
#include <mozilla/gtkembedmoz/gtkmozembed.h>
#include <caml/mlvalues.h>
#include <caml/alloc.h>
#include <caml/memory.h>
#include <caml/callback.h>
#include <caml/fail.h>

#include "wrappers.h"
#include "ml_glib.h"
#include "ml_gdk.h"
#include "ml_gtk.h"
#include "gtkmozembed_tags.h"

#include "gtkmozembed_tags.c"

static Make_Flags_val (Progress_flags_val)
static Make_Flags_val (Reload_flags_val)
static Make_Flags_val (Chrome_flags_val)

#define Make_Vallist_flags(conv) \
value Vallist_##conv (guint32 flags) \
{ CAMLparam0(); \
  CAMLlocal2( res, newres ); \
  int vars = ml_table_##conv[0].data; \
  int i; \
  res = Val_int(0); \
  for( i = 1; i<=vars; i++ ){ \
    if( (flags & ml_table_##conv[i].data) == ml_table_##conv[i].data){ \
      newres = alloc_small(2,0); \
      Field(newres, 0) = ml_table_##conv[i].key; \
      Field(newres, 1) = res; \
      res = newres; \
    } else { \
    } \
  } \
  CAMLreturn ( res ); }

static Make_Vallist_flags (status_flags)
static Make_Vallist_flags (progress_flags)
static Make_Vallist_flags (chrome_flags)
ML_1 (Vallist_status_flags, Nativeint_val, Id)
ML_1 (Vallist_progress_flags, Int_val, Id)
ML_1 (Vallist_chrome_flags, Nativeint_val, Id)

#define GtkMozEmbed_val(val) check_cast(GTK_MOZ_EMBED,val)

ML_0 (gtk_moz_embed_new, Val_GtkWidget_sink)
ML_1 (gtk_moz_embed_set_comp_path, String_val, Unit)
ML_2 (gtk_moz_embed_load_url, GtkMozEmbed_val, String_val, Unit)  
ML_1 (gtk_moz_embed_stop_load, GtkMozEmbed_val, Unit)
ML_1 (gtk_moz_embed_can_go_back, GtkMozEmbed_val, Val_bool)
ML_1 (gtk_moz_embed_can_go_forward, GtkMozEmbed_val, Val_bool)
ML_1 (gtk_moz_embed_go_back, GtkMozEmbed_val, Unit)
ML_1 (gtk_moz_embed_go_forward, GtkMozEmbed_val, Unit)
ML_5 (gtk_moz_embed_render_data, GtkMozEmbed_val, String_val, Int_val,
      String_val, String_val, Unit)
ML_3 (gtk_moz_embed_open_stream, GtkMozEmbed_val, String_val, String_val, Unit)
ML_3 (gtk_moz_embed_append_data, GtkMozEmbed_val, String_val, Int_val, Unit)
ML_1 (gtk_moz_embed_close_stream, GtkMozEmbed_val, Unit)
ML_1 (gtk_moz_embed_get_link_message, GtkMozEmbed_val, copy_string)
ML_1 (gtk_moz_embed_get_js_status, GtkMozEmbed_val, copy_string)
ML_1 (gtk_moz_embed_get_title, GtkMozEmbed_val, copy_string)
ML_1 (gtk_moz_embed_get_location, GtkMozEmbed_val, copy_string)
ML_2 (gtk_moz_embed_reload, GtkMozEmbed_val, (gint32)Flags_Reload_flags_val, Unit)
ML_2 (gtk_moz_embed_set_chrome_mask, GtkMozEmbed_val, (gint32)Flags_Chrome_flags_val, Unit)
ML_1 (gtk_moz_embed_get_chrome_mask, GtkMozEmbed_val, Vallist_chrome_flags)
